# Copyright (C) 1991-2013 Altera Corporation
# Your use of Altera Corporation's design tools, logic functions 
# and other software and tools, and its AMPP partner logic 
# functions, and any output files from any of the foregoing 
# (including device programming or simulation files), and any 
# associated documentation or information are expressly subject 
# to the terms and conditions of the Altera Program License 
# Subscription Agreement, Altera MegaCore Function License 
# Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by 
# Altera or its authorized distributors.  Please refer to the 
# applicable agreement for further details.

# Quartus II: Generate Tcl File for Project
# File: VGA_Display_Test.tcl
# Generated on: Sat Aug 16 23:26:53 2014

# Load Quartus II Tcl Project package
package require ::quartus::project

set need_to_close_project 0
set make_assignments 1

# Check that the right project is open
if {[is_project_open]} {
	if {[string compare $quartus(project) "VGA_Display_Test"]} {
		puts "Project VGA_Display_Test is not open"
		set make_assignments 0
	}
} else {
	# Only open if not already open
	if {[project_exists VGA_Display_Test]} {
		project_open -revision VGA_Display_Test VGA_Display_Test
	} else {
		project_new -revision VGA_Display_Test VGA_Display_Test
	}
	set need_to_close_project 1
}

# Make assignments
if {$make_assignments} {
	set_global_assignment -name FAMILY "Cyclone IV E"
	set_global_assignment -name DEVICE EP4CE6E22C8
	set_global_assignment -name ORIGINAL_QUARTUS_VERSION 13.0
	set_global_assignment -name PROJECT_CREATION_TIME_DATE "15:03:52  NOVEMBER 07, 2013"
	set_global_assignment -name LAST_QUARTUS_VERSION 13.0
	set_global_assignment -name PROJECT_OUTPUT_DIRECTORY output_files
	set_global_assignment -name MIN_CORE_JUNCTION_TEMP 0
	set_global_assignment -name MAX_CORE_JUNCTION_TEMP 85
	set_global_assignment -name DEVICE_FILTER_SPEED_GRADE 8
	set_global_assignment -name ERROR_CHECK_FREQUENCY_DIVISOR 1
	set_global_assignment -name USE_CONFIGURATION_DEVICE ON
	set_global_assignment -name RESERVE_ALL_UNUSED_PINS "AS OUTPUT DRIVING GROUND"
	set_global_assignment -name PARTITION_NETLIST_TYPE SOURCE -section_id Top
	set_global_assignment -name PARTITION_FITTER_PRESERVATION_LEVEL PLACEMENT_AND_ROUTING -section_id Top
	set_global_assignment -name PARTITION_COLOR 16764057 -section_id Top
	set_global_assignment -name RESERVE_ALL_UNUSED_PINS_NO_OUTPUT_GND "AS OUTPUT DRIVING AN UNSPECIFIED SIGNAL"
	set_global_assignment -name STRATIX_DEVICE_IO_STANDARD "2.5 V"
	set_global_assignment -name SDC_FILE VIP_System.sdc
	set_global_assignment -name VERILOG_FILE ../src/VGA_Display_Test.v
	set_global_assignment -name VERILOG_FILE ../src/system_index/system_init_delay.v
	set_global_assignment -name VERILOG_FILE ../src/system_index/system_ctrl_pll.v
	set_global_assignment -name VERILOG_FILE ../src/system_index/sys_pll.v
	set_global_assignment -name VERILOG_FILE ../src/lcd_index/lcd_para.v
	set_global_assignment -name VERILOG_FILE ../src/lcd_index/lcd_driver.v
	set_global_assignment -name VERILOG_FILE ../src/lcd_index/lcd_display.v
	set_global_assignment -name ENABLE_SIGNALTAP OFF
	set_global_assignment -name USE_SIGNALTAP_FILE stp1.stp
	set_global_assignment -name SLD_FILE "D:/Altera_Project/Z20140305_VIP_Board_V2_Demo/VIP_Board_Mini_LCD800480_V1.0/01_LCD_Display_Test800480/dev/stp1_auto_stripped.stp"
	set_global_assignment -name CRC_ERROR_OPEN_DRAIN OFF
	set_global_assignment -name CYCLONEII_RESERVE_NCEO_AFTER_CONFIGURATION "USE AS REGULAR IO"
	set_global_assignment -name OUTPUT_IO_TIMING_NEAR_END_VMEAS "HALF VCCIO" -rise
	set_global_assignment -name OUTPUT_IO_TIMING_NEAR_END_VMEAS "HALF VCCIO" -fall
	set_global_assignment -name OUTPUT_IO_TIMING_FAR_END_VMEAS "HALF SIGNAL SWING" -rise
	set_global_assignment -name OUTPUT_IO_TIMING_FAR_END_VMEAS "HALF SIGNAL SWING" -fall
	set_location_assignment PIN_88 -to clk
	set_location_assignment PIN_91 -to rst_n
	set_location_assignment PIN_126 -to lcd_dclk
	set_location_assignment PIN_125 -to lcd_de
	set_location_assignment PIN_121 -to lcd_vs
	set_location_assignment PIN_124 -to lcd_hs
	set_location_assignment PIN_103 -to lcd_red[4]
	set_location_assignment PIN_101 -to lcd_red[3]
	set_location_assignment PIN_100 -to lcd_red[2]
	set_location_assignment PIN_99 -to lcd_red[1]
	set_location_assignment PIN_98 -to lcd_red[0]
	set_location_assignment PIN_112 -to lcd_green[5]
	set_location_assignment PIN_111 -to lcd_green[4]
	set_location_assignment PIN_110 -to lcd_green[3]
	set_location_assignment PIN_106 -to lcd_green[2]
	set_location_assignment PIN_105 -to lcd_green[1]
	set_location_assignment PIN_104 -to lcd_green[0]
	set_location_assignment PIN_120 -to lcd_blue[4]
	set_location_assignment PIN_119 -to lcd_blue[3]
	set_location_assignment PIN_115 -to lcd_blue[2]
	set_location_assignment PIN_114 -to lcd_blue[1]
	set_location_assignment PIN_113 -to lcd_blue[0]
	set_instance_assignment -name PARTITION_HIERARCHY root_partition -to | -section_id Top

	# Commit assignments
	export_assignments

	# Close project
	if {$need_to_close_project} {
		project_close
	}
}
